Index: pjproject/branches/projects/pjsua2/pjsip/build/Makefile
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/build/Makefile	(revision 4643)
+++ pjproject/branches/projects/pjsua2/pjsip/build/Makefile	(revision 4644)
@@ -90,5 +90,6 @@
 export PJSUA2_LIB_SRCDIR = ../src/pjsua2
 export PJSUA2_LIB_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
-			   account.o endpoint.o types.o
+			   account.o endpoint.o json.o persistent.o types.o \
+			   siptypes.o
 export PJSUA2_LIB_CFLAGS += $(_CFLAGS) $(PJ_VIDEO_CFLAGS)
 export PJSUA2_LIB_CXXFLAGS = $(PJSUA2_LIB_CFLAGS) 
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2.hpp	(revision 4643)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2.hpp	(revision 4644)
@@ -22,4 +22,5 @@
 #include <pjsua2/endpoint.hpp>
 #include <pjsua2/account.hpp>
+#include <pjsua2/json.hpp>
 
 #endif
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/account.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/account.hpp	(revision 4643)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/account.hpp	(revision 4644)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2012 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2013 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
@@ -25,5 +25,6 @@
  */
 #include <pjsua-lib/pjsua.h>
-#include <pjsua2/types.hpp>
+#include <pjsua2/persistent.hpp>
+#include <pjsua2/siptypes.hpp>
 
 /**
@@ -46,5 +47,5 @@
  * Account registration config. This will be specified in AccountConfig.
  */
-struct AccountRegConfig
+struct AccountRegConfig : public PersistentObject
 {
     /**
@@ -138,4 +139,20 @@
      */
     unsigned		proxyUse;
+
+public:
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
+
 };
 
@@ -147,5 +164,5 @@
  * AccountConfig.
  */
-struct AccountSipConfig
+struct AccountSipConfig : public PersistentObject
 {
     /**
@@ -221,4 +238,19 @@
      */
     TransportId		transportId;
+
+public:
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -226,5 +258,5 @@
  * Account's call settings. This will be specified in AccountConfig.
  */
-struct AccountCallConfig
+struct AccountCallConfig : public PersistentObject
 {
     /**
@@ -265,4 +297,18 @@
     unsigned		timerSessExpiresSec;
 
+public:
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -270,5 +316,5 @@
  * Account presence config. This will be specified in AccountConfig.
  */
-struct AccountPresConfig
+struct AccountPresConfig : public PersistentObject
 {
     /**
@@ -317,4 +363,19 @@
      */
     string		pidfTupleId;
+
+public:
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -323,5 +384,5 @@
  * in AccountConfig.
  */
-struct AccountMwiConfig
+struct AccountMwiConfig : public PersistentObject
 {
     /**
@@ -342,4 +403,19 @@
      */
     unsigned		expirationSec;
+
+public:
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -348,5 +424,5 @@
  * specified in AccountConfig.
  */
-struct AccountNatConfig
+struct AccountNatConfig : public PersistentObject
 {
     /**
@@ -561,4 +637,19 @@
      */
     string		udpKaData;
+
+public:
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -567,5 +658,5 @@
  * specified in AccountConfig.
  */
-struct AccountMediaConfig
+struct AccountMediaConfig : public PersistentObject
 {
     /**
@@ -618,4 +709,19 @@
      */
     pjsua_ipv6_use	ipv6Use;
+
+public:
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -623,5 +729,5 @@
  * Account video config. This will be specified in AccountConfig.
  */
-struct AccountVideoConfig
+struct AccountVideoConfig : public PersistentObject
 {
     /**
@@ -694,4 +800,19 @@
      */
     unsigned			rateControlBandwidth;
+
+public:
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -699,5 +820,5 @@
  * Account configuration.
  */
-struct AccountConfig
+struct AccountConfig : public PersistentObject
 {
     /**
@@ -777,4 +898,17 @@
     void fromPj(const pjsua_acc_config &prm, const pjsua_media_config *mcfg);
 
+    /**
+     * Read this object from a container node.
+     *
+     * @param node		Container to read values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container node.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/config.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/config.hpp	(revision 4643)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/config.hpp	(revision 4644)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /*
- * Copyright (C) 2008-2012 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2013 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/endpoint.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/endpoint.hpp	(revision 4643)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/endpoint.hpp	(revision 4644)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /* 
- * Copyright (C) 2008-2012 Teluu Inc. (http://www.teluu.com)
+ * Copyright (C) 2013 Teluu Inc. (http://www.teluu.com)
  *
  * This program is free software; you can redistribute it and/or modify
@@ -24,5 +24,6 @@
  * @brief PJSUA2 Base Agent Operation
  */
-#include <pjsua2/types.hpp>
+#include <pjsua2/persistent.hpp>
+#include <pjsua2/siptypes.hpp>
 
 /** PJSUA2 API is inside pj namespace */
@@ -162,5 +163,5 @@
 //////////////////////////////////////////////////////////////////////////////
 
-struct UaConfig
+struct UaConfig : public PersistentObject
 {
     /**
@@ -265,4 +266,19 @@
      */
     pjsua_config toPj() const;
+
+    /**
+     * Read this object from a container.
+     *
+     * @param node		Container to write values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
+
 };
 
@@ -307,5 +323,5 @@
  * Lib::init().
  */
-struct LogConfig
+struct LogConfig : public PersistentObject
 {
     /** Log incoming and outgoing SIP message? Yes!  */
@@ -350,4 +366,18 @@
     /** Generate pjsua_logging_config. */
     pjsua_logging_config toPj() const;
+
+    /**
+     * Read this object from a container.
+     *
+     * @param node		Container to write values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -357,5 +387,5 @@
  * when calling Lib::init().
  */
-struct MediaConfig
+struct MediaConfig : public PersistentObject
 {
 public:
@@ -555,4 +585,18 @@
     /** Export */
     pjsua_media_config toPj() const;
+
+    /**
+     * Read this object from a container.
+     *
+     * @param node		Container to write values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
 };
 
@@ -561,5 +605,5 @@
  * Endpoint configuration
  */
-struct EpConfig
+struct EpConfig : public PersistentObject
 {
     /** UA config */
@@ -571,4 +615,19 @@
     /** Media config */
     MediaConfig		medConfig;
+
+    /**
+     * Read this object from a container.
+     *
+     * @param node		Container to write values from.
+     */
+    virtual void readObject(const ContainerNode &node) throw(Error);
+
+    /**
+     * Write this object to a container.
+     *
+     * @param node		Container to write values to.
+     */
+    virtual void writeObject(ContainerNode &node) const throw(Error);
+
 };
 
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/json.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/json.hpp	(revision 4644)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/json.hpp	(revision 4644)
@@ -0,0 +1,114 @@
+/* $Id$ */
+/*
+ * Copyright (C) 2013 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+#ifndef __PJSUA2_JSON_HPP__
+#define __PJSUA2_JSON_HPP__
+
+/**
+ * @file pjsua2/persistent.hpp
+ * @brief PJSUA2 Persistent Services
+ */
+#include <pjsua2/persistent.hpp>
+#include <pjlib-util/json.h>
+#include <pj/pool.h>
+#include <string>
+
+/**
+ * @defgroup PJSUA2_JSON JSON Persistent Support
+ * @ingroup PJSUA2_PERSISTENT
+ * @{
+ * Provides object serialization and deserialization to/from JSON document.
+ */
+
+/** PJSUA2 API is inside pj namespace */
+namespace pj
+{
+using std::string;
+
+
+class JsonDocument : public PersistentDocument
+{
+public:
+    /** Default constructor */
+    JsonDocument();
+
+    /** Destructor */
+    ~JsonDocument();
+
+    /**
+     * Load this document from a file.
+     *
+     * @param filename		The file name.
+     */
+    virtual void   loadFile(const string &filename) throw(Error);
+
+    /**
+     * Load this document from string.
+     *
+     * @param input		The string.
+     */
+    virtual void   loadString(const string &input) throw(Error);
+
+    /**
+     * Write this document to a file.
+     *
+     * @param filename		The file name.
+     */
+    virtual void   saveFile(const string &filename) throw(Error);
+
+    /**
+     * Write this document to string.
+     */
+    virtual string saveString() throw(Error);
+
+    /**
+     * Get the root container node for this document
+     */
+    virtual ContainerNode & getRootContainer() const;
+
+    /**
+     * An internal function to create JSON element.
+     */
+    pj_json_elem*    allocElement() const;
+
+    /**
+     * An internal function to get the pool.
+     */
+    pj_pool_t*	     getPool();
+
+private:
+    pj_caching_pool	  cp;
+    mutable ContainerNode rootNode;
+    mutable pj_json_elem *root;
+    mutable pj_pool_t	 *pool;
+
+    void initRoot() const;
+};
+
+
+
+
+} // namespace pj
+
+/**
+ * @}  PJSUA2
+ */
+
+
+
+#endif	/* __PJSUA2_JSON_HPP__ */
